import {
  isDarkMode
} from "./chunk-YETZPQFR.js";
import {
  READ_STATES,
  twoFAStates
} from "./chunk-A6CT6GTI.js";
import {
  DEVICE_ONLINE_CUTOFF,
  defaultIdAttribute
} from "./chunk-4B3IMP4I.js";

// src/usersSlice/selectors.ts
import { createSelector } from "@reduxjs/toolkit";
var getRolesById = (state) => state.users.rolesById;
var getTooltipsById = (state) => state.users.tooltips.byId;
var getGlobalSettings = (state) => state.users.globalSettings;
var getCurrentUserId = (state) => state.users.currentUser;
var getUsersById = (state) => state.users.byId;
var getCurrentUser = createSelector([getUsersById, getCurrentUserId], (usersById, userId) => usersById[userId] ?? {});
var getUserSettings = (state) => state.users.userSettings;
var getIsDarkMode = createSelector([getUserSettings], ({ mode }) => isDarkMode(mode));
var getShowHelptips = createSelector(
  [getTooltipsById],
  (tooltips) => Object.values(tooltips).reduce((accu, { readState }) => accu || readState === READ_STATES.unread, false)
);
var getTooltipsState = createSelector(
  [getTooltipsById, getUserSettings],
  (byId, { tooltips = {} }) => Object.entries(byId).reduce(
    (accu, [id, value]) => {
      accu[id] = { ...accu[id], ...value };
      return accu;
    },
    { ...tooltips }
  )
);
var getHas2FA = createSelector(
  [getCurrentUser],
  (currentUser) => currentUser.hasOwnProperty("tfa_status") && currentUser.tfa_status === twoFAStates.enabled
);
var getIdAttribute = createSelector([getGlobalSettings], ({ id_attribute = { ...defaultIdAttribute } }) => id_attribute);
var getOfflineThresholdSettings = createSelector([getGlobalSettings], ({ offlineThreshold }) => ({
  interval: offlineThreshold?.interval || DEVICE_ONLINE_CUTOFF.interval,
  intervalUnit: offlineThreshold?.intervalUnit || DEVICE_ONLINE_CUTOFF.intervalName
}));
var getRolesList = createSelector([getRolesById], (rolesById) => Object.entries(rolesById).map(([id, role]) => ({ id, ...role })));
var getCurrentSession = (state) => state.users.currentSession;

export {
  getRolesById,
  getTooltipsById,
  getGlobalSettings,
  getCurrentUser,
  getUserSettings,
  getIsDarkMode,
  getShowHelptips,
  getTooltipsState,
  getHas2FA,
  getIdAttribute,
  getOfflineThresholdSettings,
  getRolesList,
  getCurrentSession
};
//# sourceMappingURL=chunk-KAQJH2YL.js.map